'use strict';

var Interface, extend;

Interface       = require('./Interface');
extend          = require('../utils/extend');

function Node (string, nodes) {

  this.getParent().apply(this, arguments);

  this
    .setType('Boolean Literal')
    .setType('Reserved Word')
  ;

  return this;

}

extend(Interface, Node);

Node.fn = Node.prototype;

Node.fn.detect = function () {

  return 'Boolean Literal';

};

Node.is = function (string, nodes) {

  var Nodes;

  Nodes = require('../lib/nodes');

  var previous;

  if (string !== 'true' && string !== 'false') {
    return false
  }

  if (nodes.length === 0) {
    return true;
  }

  previous = Nodes.getLast(
    nodes
  );

  return !previous.is('Dot Operator');

};

module.exports = Node;