'use strict';

function Interface (string, nodes, strings, index) {

  this.string = string  ;
  this.nodes  = nodes   ;

  this.previous = null;

  this.types = [];

  this.chain();

  this.setName(
    this.detect(strings, index)
  );

  return this;

}

Interface.fn = Interface.prototype;

Interface.fn.getTypes = function () {
  return this.types;
};

Interface.fn.getString = function () {
  return this.string;
};

Interface.fn.getNodes = function () {
  return this.nodes;
};

Interface.fn.setType = function (type) {

  var types;

  types = this.getTypes();

  types.push(
    type
  );

  return this;

};

Interface.fn.setName = function (name) {

  this.name = name;

  return this;

};

Interface.fn.getName = function () {

  return this.name;

};

Interface.fn.is = function (name) {

  return this.getName() === name;

};

Interface.fn.setPrevious = function (node) {

  this.previous = node;

  return this;

};

Interface.fn.getPrevious = function () {
  return this.previous;
};

Interface.fn.chain = function () {

  var Nodes, length, last;

  Nodes = require('../lib/nodes');

  length = this.getNodes().length;

  if (length > 0) {

    last = Nodes.getLast(
      this.getNodes()
    );

    this.setPrevious(
      last
    );

    return this;

  }

  this.setPrevious(
    null
  );

  return this;

};

Interface.fn.parent = Interface;

Interface.fn.getParent = function () {
  return this.parent;
};

module.exports = Interface;

