'use strict';

var Interface, extend;

Interface       = require('./Interface');
extend          = require('../utils/extend');

function Node (string, nodes) {

  this.getParent().apply(this, arguments);

  this
    .setType('Reserved Word')
    .setType('Keyword')
    .setType('Statement')
  ;

  return this;

}

extend(Interface, Node);

Node.fn = Node.prototype;

Node.fn.detect = function () {

  return 'The case Statement';

};

Node.is = function (string, nodes) {

  var Nodes;

  Nodes = require('../lib/nodes');

  var previous;

  if (string !== 'case') {
    return false;
  }

  if (nodes.length === 0) {
    return false;
  }

  previous = Nodes.getLast(
    nodes
  );

  if (previous.is('Dot Operator') || previous.is('Comma Operator')) {
    return false;
  }

  if (previous.is('Left Brace') && !previous.getPrevious().is('Right Parenthesis')) {
    return false;
  }

  return true;

};

module.exports = Node;