'use strict';

var Interface, extend;

Interface       = require('./Interface');
extend          = require('../utils/extend');

function Node (string, nodes) {

  this.getParent().apply(this, arguments);

  this
    .setType('Reserved Word')
    .setType('Keyword')
    .setType('Statement')
  ;

  return this;

}

extend(Interface, Node);

Node.fn = Node.prototype;

Node.fn.detect = function () {

  return 'The Variable Statement';

};

Node.is = function (string, nodes) {

  var Nodes;

  Nodes = require('../lib/nodes');

  var previous;

  if (string !== 'var') {
    return false;
  }

  if (nodes.length === 0) {
    return true;
  }

  previous = Nodes.getLast(
    nodes
  );

  if (previous.is('Dot Operator') || previous.is('Comma Operator')) {
    return false;
  }

  if (previous.is('Left Brace')) {

    switch (previous.getPrevious().getName()) {

      case 'Right Parenthesis':
      case 'The else Statement':
      case 'The catch Statement':
      case 'The finally Statement':
      case 'The do Statement':
      case 'The return Statement':
      case 'The try Statement':
        return true;

    }

    return false;

  }

  return true;

};

module.exports = Node;