'use strict';

var Interface, extend;

Interface       = require('./Interface');
extend          = require('../utils/extend');

function Node (string, nodes) {

  this.getParent().apply(this, arguments);

  this
    .setType('Word')
  ;

  return this;

}

extend(Interface, Node);

Node.fn = Node.prototype;

Node.fn.detect = function (strings, index) {

  var previous, next;

  previous = this.getPrevious();

  next = typeof strings[index + 1] === 'undefined' ? null: strings[index + 1];

  if (previous === null) {
    return 'Global Variable Name';
  }

  if (previous.is('Dot Operator')) {
    return "The Object's Property Name";
  }

    if (previous.is('The Function Definition')) {
        return "The Function Name";
    }

  if (next !== null && next === ':') {
    return "The Object's Property Name";
  }

  return 'Variable Name';

};

Node.is = function (string, nodes) {

  return /^[a-zA-Z\$\_]{1}[a-zA-Z0-9\$\_]*$/.test(string);

};

module.exports = Node;