'use strict';

/**
 * Basic tool for extend parent class.
 * @author Roman Yakimchuk
 * @public
 * @this {Object} Window
 * @param {Function} Parent Parent class.
 * @param {Function} Child Child class.
 * @returns {null}
 */
module.exports = function (Parent, Child) {

  var Intermediate, instance, property;

  Intermediate = function () {};

  Intermediate.prototype = Parent.prototype;

  instance = new Intermediate();

  for (property in Child.prototype) {
    instance[property] = Child.prototype[property];
  }

  Child.prototype = instance;

  return null;

};